#!/usr/bin/python
# -*- coding:utf-8 -*-


class Error(Exception):
	'''Base class for exceptions in this module.'''
	pass


class IncorrectTypeException(Exception):
	'''  '''
	
	def __init__(self, clase, atribute, comment=''):
		''' IncorrectTypeException constructor '''
		self.class_name = clase
		self.atribute = atribute
		self.comment = comment
		
	def __str__(self):
		''' IncorrectTypeException String function '''
		buffer = "Error: invalid atribute %s, on class %s \n Reason%s " %( self.atribute, self.class_name, self.comment)   
		return buffer


class DuplicateHardware (Error):
	'''Exception raised when a Hardware is added and it already exists.
	Attributes:
	function -- name of the function that raise the exception
	comment  -- optional.'''

	def __init__ ( self, function, comment="" ):
		''' '''
		self.function = function
		self.comment = comment
	
	def __str__(self):
		return "DuplicateHardware: hardware object is already added. Function: %s. %s"\
		%(function, comment)
		

class DuplicateExpedientException (Error):
	''' '''
	def __init__ ( self, function, comment="" ):
		''' '''
		self.function = function
		self.comment = comment
	
	def __str__(self):
		return "DuplicateExpedientException: hardware object is already added. Function: %s. %s"\
		%(function, comment)


class DuplicateDictionaryKeyException(Exception):
	''' '''
	
	def __init__(self, clas):
		''' DuplicateDictionaryKeyException Constructor '''
		self.clas = clas
	
	def __str__ (self):
		''' DuplicateDictionaryKeyException String function '''
		buffer =" Error: the introduce key already exists in class %s" %(self.clase)
		return buffer

