#!/usr/bin/python
#! coding:utf-8 -*-

from sys import path

class Regla:
	''' '''
	def __init__( self, version, expediente, hardware_list=[]):
		''' '''
		# version = time.localtime(int(time.time()))
		if not isinstance( version, long):
			raise IncorrectTypeException ("Regla", "version")
		else:
			self.version = version
		if not isinstance(expediente, Expediente):
			raise IncorrectTypeException ("Regla", "expediente")
		else:
			self.expediente = expediente
		for hw in hardware_list:
			if not isinstance(hw, Hardware):
				raise IncorrectTypeException ("Regla", "object in hardware_list")
		self.hardware_list = hardware_list
	
	def __str__ (self):
		''' '''
		to_string = "Regla. version=%s   %s" %(str(self.version),str(self.expediente))
		for hw in self.hardware_list:
			to_string = to_string+"%s\n" %(str(hw))
		return to_string

	def add_hardware( self, new_hw ):
		''' This method add a new hardware object to the list
		only if doesn't exist another hardware with the same '''
		if not isinstance (new_hw, Hardware):
			raise IncorrectTypeException ("Regla", "new_hardware", "function add_hardware")
		else:
			founded = False
			for element in self.hardware_list:
				if new_hw.id_hardware == element.id_hardware:
					founded = True
					break
			if founded == True:
				raise DuplicateHardware("Regla")
			else:
				self.hardware_list.append(new_hw)

	def del_hardware( self, hardware ):
		''' Remove the first occurrence Hardware object in hardware_list
		with the same id_hardware'''
		if not isinstance(hardware, Hardware):
			raise IncorrectTypeException ("Regla", "hardware", "Function del_hardware")
		else:
			founded = False
			for hw_element in self.hardware_list:
				if hw_element.id_hardware == hardware.id_hardware:
					self.hardware_list.remove(hw_element)

